﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Client As Socket
	Dim Astreams As AsyncStreams
End Sub

Sub Service_Create
	Client.Initialize("Client")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub


public Sub Connect
	'CltSock.Close
	Client.Initialize("Client")
	Client.Connect(Starter.ip,Starter.port,10000)
End Sub

Sub Client_Connected(ConStatus As Boolean)
	Log("Conn: " & ConStatus)
	If ConStatus Then
		Astreams.Initialize( Client.InputStream, Client.OutputStream, "AStreams")
		Astreams.Write(ToByte("NICK " & Starter.Nickname))
		Astreams.Write(ToByte("USER " & Starter.Nickname & " 0 * ..."))
	Else
		CallSub3(Main,"ErrorMessage",LastException.Message, "Error connecting")
	End If
End Sub

Sub AStreams_NewData (Buffer() As Byte)
	Process(BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
End Sub

Sub Process(Msg As String)
	Dim Destin As String
	Starter.Message = Starter.Message  & Msg

	If Starter.Message.Contains(CRLF) Then
		Msg=Starter.Message.SubString2(0,Starter.Message.LastIndexOf(CRLF))
		Starter.Message=Starter.Message.SubString(Starter.Message.LastIndexOf(CRLF)+1)
		
		Dim Msgs() As String = Regex.Split(CRLF,Msg)
		
		For Each Single As String In Msgs
			LogColor(Single,Colors.Magenta)
			If Single.StartsWith(":") Then
				Destin=Single.SubString2(0,Single.IndexOf(" ")).Replace(":","")
				Single=Single.SubString(Single.IndexOf(" ")+1)
			End If
			Single=Single.Trim.Replace(Chr(13),"").Replace(Chr(10),"").Replace(":","")
			Dim Com() As String = Regex.Split(" ",Single)
			Log(Single)
			Select Com(0).Trim
				Case "NICK"
					If Destin.StartsWith(Starter.Nickname) Or Destin="" Then
						Starter.Nickname=Com(1)
						StartActivity(rooms)
						If Starter.RoomActive Then CallSub(MyRoom,"Nick")
						Astreams.Write(ToByte("USER " & Starter.Nickname & " 0 * ..,"))
						CallSub(rooms,"Nick")
					Else
						'cambio altro nick
						Dim Pos As Int = Starter.ListNick.IndexOf(Destin)
						If Pos>-1 Then 
							Starter.ListNick.RemoveAt(Pos)
							Starter.ListNick.InsertAt(Pos,Com(1))
							If Starter.RoomActive Then 
								CallSub(MyRoom,"Nick")
								CallSub3(MyRoom,"Message","", Destin & " change in " & Com(1))
							End If
						End If
					End If
				Case "PRIVMSG"
					CallSub3(MyRoom,"Message",Destin,Com(3))
				Case "PING"
					Astreams.Write(ToByte(Single.Replace("PING","PONG")))
				Case "JOIN"
					If Destin=Starter.Nickname Then 
						' sei entrato in room
						Starter.ActualRoom=Com(1)
					Else
						' qualcuno é entrato in room
						Starter.ListNick.Add(Com(1))
					End If
					StartActivity(MyRoom)
				Case "321"
					'Start room
					Starter.ListRoom.Clear
					CallSub(rooms,"ClearRoom")
				Case "322"
					'Add room
					Starter.ListRoom.Add(Com(2))
					CallSub2(rooms,"AddRoom",Com(2))
				Case "323"
					'End room
				Case "331"
					'Clear Nick List
					Starter.ListNick.Clear
				Case "353"
					'Add Nick
					For i=4 To Com.Length-1
						Starter.ListNick.Add(Com(i))
					Next
				Case "366"
					CallSub(MyRoom,"UpdateList")
					'End of mame list
				Case "376"
					Astreams.Write(ToByte("LIST" & CRLF))
				Case "NOTICE"
					LogColor(Single,Colors.Blue)
					If Single.IndexOf("/MSG NickServ IDENTIFY password")>-1 Then
						CallSub(rooms,"Nick")
						CallSub2(Main,"Notice",Com(1))
						If Starter.Password<>"" Then Astreams.Write(ToByte("PRIVMSG " & Starter.Nickname & " IDENTIFY " & Starter.Password))
					Else
						'private message
						CallSub2(Main,"Notice",Single.Replace("notice",""))
						CallSub2(rooms,"Notice",Single.Replace("notice",""))
					End If
				Case Else
					'Logcolor(Single, Colors.Green)
			End Select
		Next
	End If
End Sub

#Region Function

Sub ToByte(S As String) As Byte()
	Dim M As String = S & Chr(10) & Chr(13)
	LogColor(S,Colors.Red)
	Return M.GetBytes("UTF8")
End Sub

#End Region