﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

public Sub LoadDrawableByName(Control As View, ImageName As String) As Boolean
	Dim R As Reflector
	Try
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		R.Target = R.RunMethod("getSystem")
		Dim ID_Drawable As Int
		ID_Drawable = R.RunMethod4("getIdentifier", Array As Object(ImageName, "drawable", "android"), _
		                                            Array As String("java.lang.String", "java.lang.String", "java.lang.String"))
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		Control.Background = R.RunMethod2("getDrawable", ID_Drawable, "java.lang.int")
		Return True
		
	Catch
		LogColor("ERROR.LoadDrawableByName:" & LastException.Message, Colors.Red)
		Return False
		
	End Try
End Sub

public Sub radius(View As View, CornerRadius As Int,Color As Int,BorderWidth As Int, BorderColor As Int)
	Dim cdb As ColorDrawable

	cdb.Initialize2(Color,CornerRadius,BorderWidth,BorderColor)
	View.Background = cdb
End Sub

' PorterDuff.Mode
' https://developer.android.com/reference/android/graphics/PorterDuff.Mode.html
Public Sub filter (Background As Object, Color As Int, FilterName As String)
	Dim jo As JavaObject = Background
	jo.RunMethod("setColorFilter", Array As Object(Color, FilterName))
End Sub

Sub ToastMessage(Text As Object, LongDuration As Boolean, BackgroundColor As Int)
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	Dim duration As Int
	If LongDuration Then duration = 1 Else duration = 0
	Dim Toast As JavaObject
	Toast = Toast.InitializeStatic("android.widget.Toast").RunMethod("makeText", Array(ctxt, Text, duration))
	Dim v As View = Toast.RunMethod("getView", Null)
	Dim cd As ColorDrawable
	cd.Initialize2(BackgroundColor, 10dip,1dip,Colors.Black )
	v.Background = cd
	'uncomment to show toast in the center:
	'   toast.RunMethod("setGravity", Array( _
	'       Bit.Or(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL), 0, 0))
	Toast.RunMethod("show", Null)
End Sub