﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private PanelMainRoom As Panel
	Private PanelNick As Panel
	Private PanelList As Panel
	Private LabelNick As Label
	Private LabelRoom As Label
	Private ChatRoom As EditText
	Private DigitText As EditText
	Private ListNick As ListView
	Private ButtonOk As Button
	
	Dim IMeK As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("room")
	funzioni.LoadDrawableByName(ButtonOk,"ic_menu_send")
	
	PanelMainRoom.Height=100%y
	ListNick.SingleLineLayout.Label.TextColor=Colors.Black
	DigitText.Color=Colors.ARGB(200,200,200,200)
	LabelRoom.Text=Starter.ActualRoom
	
	IMeK.Initialize("IMeK")
	IMeK.AddHandleActionEvent(DigitText)
	IMeK.AddHeightChangedEvent
	
	Nick
	UpdateList
	AdjutPanel
End Sub

Sub Activity_Resume
	Starter.RoomActive=True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Starter.RoomActive=False
End Sub

Public Sub UpdateList
	ListNick.Clear
	For Each NickName As String In Starter.ListNick
		ListNick.AddSingleLine(NickName)
	Next
End Sub

Public Sub Nick
	LabelNick.Text=Starter.Nickname
End Sub

Public Sub Message(NickName As String, Msg As String)
	ChatRoom.Text =$"${ChatRoom.Text}${NickName}: ${Msg}${CRLF}"$ 
	ChatRoom.SelectionStart=ChatRoom.Text.Length
End Sub

Sub IMeK_HeightChanged (NewHeight As Int, OldHeight As Int)
	PanelMainRoom.Height=NewHeight
	AdjutPanel
End Sub

Sub AdjutPanel
	DigitText.Top=PanelMainRoom.Height-DigitText.Height
	ButtonOk.Top=PanelMainRoom.Height-ButtonOk.Height
	ButtonOk.Left=PanelMainRoom.Width-ButtonOk.Width
	
	ListNick.Height=PanelMainRoom.Height-DigitText.Height-PanelNick.Height-1dip
	PanelList.Height=PanelMainRoom.Height-DigitText.Height-PanelNick.Height-1dip
	ChatRoom.Height=PanelMainRoom.Height-DigitText.Height-PanelNick.Height-1dip
End Sub

Sub ButtonOk_Click
	Dim Mess As String = "PRIVMSG " & Starter.ActualRoom & " " & DigitText.Text & CRLF
	
	DigitText.Text=""
	ClientService.Astreams.Write(Mess.GetBytes("UTF8"))
End Sub